<?php

namespace FormatConverter\Adapters;

use FormatConverter\Interfaces\FormatAdapterInterface;
use FormatConverter\Utils\ArrayToXml;

class XmlAdapter implements FormatAdapterInterface
{
    public function deserialize(string $data)
    {
        $xml = simplexml_load_string($data, "SimpleXMLElement", LIBXML_NOCDATA);
        return json_decode(json_encode($xml), true);
    }

    public function serialize($data): string
    {
        $xml = new \SimpleXMLElement('<?xml version="1.0"?><root></root>');
        ArrayToXml::convert($data, $xml);
        $rawXml = $xml->asXML();

        try {
            $dom = new \DOMDocument();
            $dom->preserveWhiteSpace = false;
            $dom->formatOutput = true;
            
            $dom->loadXML($rawXml);
            
            // XML formateado
            return $dom->saveXML();
        } catch (\Exception $e) {
            return $rawXml;
        }
    }
}
