<?php

namespace FormatConverter\Interfaces;

interface FormatAdapterInterface
{
    /**
     * Convertir data desde formato nativo a formato array|object de PHP
     * 
     * @param string $data
     * @return array|object
     */
    public function deserialize(string $data);

    /**
     * Convertir data desde formato array|object de PHP a formato nativo
     * 
     * @param array|object $data
     * @return string
     */
    public function serialize($data): string;
}