<?php

namespace FormatConverter\Utils;

class ArrayToXml
{
    /**
     * Convierte un array a XML.
     *
     * @param array|object $data
     * @param \SimpleXMLElement $xml
     */
    public static function convert($data, \SimpleXMLElement &$xml)
    {
        foreach ($data as $key => $value)
        {
            if (is_numeric($key)) {
                $key = 'item';
            }
            if (is_array($value) || is_object($value)) {
                $subnode = $xml->addChild($key);
                self::convert($value, $subnode);
            } else {
                $xml->addChild("$key", htmlspecialchars("$value"));
            }
        }
    }
}